]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: fix a minor misspelling
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
75       if [ "$SHELL" = /bin/bash ]; then
76          if [ -f /etc/bash_completion ]; then
77             . /etc/bash_completion
78          elif [ -d /etc/bash_completion.d ]; then
79             . /etc/bash_completion.d/*
80          fi
81       elif [ "$SHELL" = /usr/local/bin/bash ]; then
82          if [ -d /usr/local/etc/bash_completion.d ]; then
83             . /usr/local/etc/bash_completion.d/*
84          fi
85       else
86          echo "Unknown OS type, cannot source bash_completion" >&2
87       fi
88    fi
89
90    has_completion() { return 0; }
91    if [ "$SHELL" = /bin/bash ]; then
92       if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
93          has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
94       fi
95    elif [ "$SHELL" = /usr/local/bin/bash ]; then
96       if [ -d /usr/local/etc/bash_completion.d ]; then
97          has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
98       fi
99    fi
100
101    for cmd in builtin cgmem_nice command dbus-launch exec \
102       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
103       time whence whereis which xargs; do
104          ! has_completion $cmd && complete -o default -A command $cmd
105    done
106
107    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
108       telnet t tt \
109       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
110       whois wget wget-m wget-wrapper ww; do
111          ! has_completion $cmd && complete -A hostname $cmd
112    done
113
114    for cmd in distribute ftp lftp r rsync \
115       s scp ssh smbclient tcpdump tshark wireshark; do
116          ! has_completion $cmd && complete -o default -A hostname $cmd;
117    done
118
119    delegate_completion() {
120       local prog completion_f programs
121       prog="$1"
122       if has_completion "$prog"; then
123          completion_f="$2"
124          shift; shift
125          programs="$@"
126          eval "_${prog}_completion_loader() {
127             _completion_loader $prog
128             complete -F $completion_f $programs
129             unset _${prog}_completion_loader
130             return 124
131          }"
132          complete -F _"$prog"_completion_loader $programs
133       fi
134    }
135
136    delegate_completion make _make m
137    delegate_completion ping _ping p
138    delegate_completion rsync _rsync r
139    delegate_completion ssh _ssh s
140    delegate_completion wget _wget wget-m wget-wrapper ww
141
142    unset has_completion delegate_completion
143
144    complete -A job bg fg j jobs wait
145    complete -A variable -A function unset
146
147    if [ -d "$HOME/lib/config" ]; then
148       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
149    fi
150    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
151
152    #if type -p pip >/dev/null 2>&1; then
153    #   eval "`pip completion --bash`"
154    #   rm -rf /tmp/pip_build_"$USER"
155    #fi
156
157    #if which pyenv >/dev/null 2>&1; then
158    #   eval "`pyenv init -`"
159    #   eval "`pyenv virtualenv-init -`"
160    #fi
161
162    source virtualenvwrapper_lazy.sh 2>/dev/null
163
164    #if [ -n "$VIRTUAL_ENV" ]; then
165    #   . "$VIRTUAL_ENV/bin/activate"
166    #fi
167
168 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
169    back() { cd - "$@"; }
170    j() { jobs; }
171 fi
172
173
174 # clear screen and history, logout
175 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
176
177
178 if test -x /usr/bin/git >/dev/null 2>&1; then
179    # chdir to a remote's directory (if the remote is on the local FS)
180    cdremote() {
181       if [ -z "$1" -o -n "$2" ]; then
182          echo "Usage: cdremote remote_name" >&2
183          return 1
184       fi
185       cd "`git config --get remote.$1.url`"
186    }
187
188    if test -n "$BASH_VERSION"; then
189       # completion for global aliases in .gitconfig
190
191       # fixup rbi rbia rbiap rbip - do refs name completion
192       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
193       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
194       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
195       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
196       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
197       #
198       # push-to-all-remotes - do branch name completion
199       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
200
201       # list remotes with URLs matching a regexp
202       _list_remotes() {
203          if [ -z "$1" -o -n "$2" ]; then
204             echo "Usage: _list_remotes remote_regexp" >&2
205             return 1
206          fi
207          GIT_REMOTES=""
208          local remote
209          for remote in `git remote`; do
210             if git config --get remote.$remote.url | grep -q "$1"; then
211                GIT_REMOTES="$GIT_REMOTES $remote"
212             fi
213          done
214       }
215
216       # completion for cdremote and git-open - list remotes with a pattern
217       _list_remotes_completion() {
218          local cur="${COMP_WORDS[COMP_CWORD]}";
219          _list_remotes "$1"
220          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
221          unset GIT_REMOTES
222       }
223
224       # completion for cdremote - list remotes with directories as URLs
225       _cdremote_complete() {
226          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
227       }
228
229       complete -F _cdremote_complete cdremote
230
231       # completion for git-open - list remotes with http(s) URLs
232       _git_open() {
233          _list_remotes_completion '^http\(s\)\?://'
234       }
235
236       complete -F _git_open git-open
237    fi
238 fi
239
240
241 include() {
242    cfg="$1"
243    if [ -f "./$cfg" -a -r "./$cfg" ]; then
244       echo "Reading config file \`$cfg'" 1>&2
245       . "./$cfg"
246    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
247       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
248       . "$HOME/lib/config/$cfg"
249    else
250       echo "Cannot find config file \`$cfg'" 1>&2
251    fi
252 }
253
254
255 mc() {
256    if test -n "$BASH_VERSION"; then
257       MC_SAVE_OPS1="$OPS1"
258       OPS1="\u@\h "
259    fi
260
261    if [ -n "$SLOWTERM" ]; then
262       MC_SLOW="--slow"
263    fi
264
265    case "$TERM" in
266       screen*) # screen, screen.rxvt
267          if [ "$TERM" = screen.rxvt ]; then
268             MC_SAVE_TERM="$TERM"
269             TERM=rxvt
270          fi
271          MC_XTERM="-x"
272       ;;
273    esac
274
275    #TMPDIR="$HOME"/tmp
276    #export TMPDIR
277
278    MC_FOUND=NO
279
280    for wrapper in \
281          /usr/local/share/mc/bin/mc-wrapper.sh \
282          /usr/local/libexec/mc/mc-wrapper.sh \
283          /usr/share/mc/bin/mc-wrapper.sh; do
284       if [ -r $wrapper ]; then
285          . $wrapper $MC_SLOW $MC_XTERM "$@"
286          rc=$?
287          MC_FOUND=YES
288          break
289       fi
290    done
291
292    if [ $MC_FOUND = NO ]; then
293       for mc in /usr/local/bin/mc /usr/bin/mc; do
294          if [ -x $mc ]; then
295             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
296             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
297                MC_TMP_DIR="${TMPDIR-/tmp}"
298             fi
299             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
300             mc_type="`mc_type.py $mc`"
301             if [ "$mc_type" = old ]; then
302                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
303             elif [ "$mc_type" = new ]; then
304                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
305             else
306                continue
307             fi
308             rc=$?
309             MC_FOUND=YES
310             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
311             break
312          fi
313       done
314    fi
315
316    if [ $MC_FOUND = NO ]; then
317       echo "Cannot find mc-wrapper.sh or mc" >&2
318       rc=1
319    fi
320
321    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
322    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
323    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
324          MC_SLOW MC_TMP_DIR MC_XTERM
325
326    return $rc
327 }
328
329
330 mkcd() {
331    if [ $# -ne 1 ]; then
332       echo "Usage: mkcd directory_name" >&2
333    elif [ -d "$1" ]; then
334       cd "$1"
335    elif [ -e "$1" ]; then
336       echo "Error: $1 is a file" >&2
337    else
338       mkdir -p "$1" && cd "$1"
339    fi
340 }
341
342
343 if which tmux >/dev/null 2>&1; then
344    tmux() {
345       case "$TERM" in
346          rxvt)
347             TERM=rxvt-unicode command tmux "$@"
348          ;;
349
350          *)
351             command tmux "$@"
352          ;;
353       esac
354    }
355 fi
356
357
358 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
359    X() { startx >> .Xserver.log 2>&1; cyr; }
360 fi
361
362 x() { exit; }